// DS1302 Clock Module
// Chin-Shiuh Shieh on 2021-12-11

// #define DS1302_CE   P2_0
// #define DS1302_SCLK P2_1
// #define DS1302_IO   P2_2

// DS1302_write(0x8C,0x14); // Set Year
// DS1302_write(0x8A,0x06); // Set Day
// DS1302_write(0x88,0x12); // Set Month 
// DS1302_write(0x86,0x11); // Set Date
// DS1302_write(0x84,0x13); // Set Hour
// DS1302_write(0x82,0x46); // Set Minute
// DS1302_write(0x80,0x00); // Set Second
// DS1302_read(0x8D); // Read Year
// DS1302_read(0x8B); // Read Day
// DS1302_read(0x89); // Read Month
// DS1302_read(0x87); // Read Date
// DS1302_read(0x85); // Read Hour
// DS1302_read(0x83); // Read Minute
// DS1302_read(0x81); // Read Second

void DS1302_write(unsigned char cmd,unsigned char value){
  unsigned char i;
  DS1302_CE=DS1302_SCLK=DS1302_IO=0;
  DS1302_CE=1;
  for(i=0;i<8;i++){
    if(cmd%2==1)DS1302_IO=1;else DS1302_IO=0;cmd>>=1;
    DS1302_SCLK=1;DS1302_SCLK=0;
  }
  for(i=0;i<8;i++){
    if(value%2==1)DS1302_IO=1;else DS1302_IO=0;value>>=1;
    DS1302_SCLK=1;DS1302_SCLK=0;
  }
  DS1302_CE=0;
}

unsigned char DS1302_read(unsigned char cmd){
  unsigned char i,value=0;
  DS1302_CE=DS1302_SCLK=DS1302_IO=0;
  DS1302_CE=1;
  for(i=0;i<7;i++){
    if(cmd%2==1)DS1302_IO=1;else DS1302_IO=0;cmd>>=1;
    DS1302_SCLK=1;DS1302_SCLK=0;
  }
  if(cmd%2==1)DS1302_IO=1;else DS1302_IO=0;cmd>>=1;
  DS1302_SCLK=1;
  DS1302_IO=1;
  for(i=0;i<7;i++){
    DS1302_SCLK=0;
    value>>=1;if(DS1302_IO==1)value+=128;
    DS1302_SCLK=1;
  }
  DS1302_SCLK=0;
  value>>=1;if(DS1302_IO==1)value+=128;
  DS1302_CE=0;
  return(value);
}
